import * as React from "react";
import { Subject } from "rxjs";
interface Props {
    data: {
        model_id: string;
    };
    channels: Subject<any>;
}
/**
 * Component used to render a widget view.
 *
 * Given a kernel and widget model id, this component will render a widget
 * view for the widget model. The widget view and widget models are isolated to
 * a cross domain iframe. Since they have access to the kernel, they are capable
 * of communicating directly with the kernel instance which makes them atypical.
 *
 * Even though it may appear to be pure, since it doesn't have react state, this
 * component's iframe maintains it's own state in communication with the kernel.
 */
export declare class WidgetDisplay extends React.Component<Partial<Props>> {
    static MIMETYPE: string;
    private container;
    /** @override */
    componentDidMount(): void;
    /** @override */
    componentWillUnmount(): void;
    /** @override */
    shouldComponentUpdate(nextProps: Props): boolean;
    /** @override */
    render(): JSX.Element;
    /**
     * Creates or updates the existing shim to the current model id and kernel.
     */
    private createOrUpdateShim;
}
export {};
